# Babel Starter Kit

[![NPM version](http://img.shields.io/npm/v/generator-javascript.svg?style=flat-square)](https://www.npmjs.com/package/generator-javascript)
[![NPM downloads](http://img.shields.io/npm/dm/generator-javascript.svg?style=flat-square)](https://www.npmjs.com/package/generator-javascript)
[![Build Status](http://img.shields.io/travis/kriasoft/babel-starter-kit/master.svg?style=flat-square)](https://travis-ci.org/kriasoft/babel-starter-kit)
[![Coverage Status](https://img.shields.io/coveralls/kriasoft/babel-starter-kit.svg?style=flat-square)](https://coveralls.io/github/kriasoft/babel-starter-kit)
[![Dependency Status](http://img.shields.io/david/dev/kriasoft/babel-starter-kit.svg?style=flat-square)](https://david-dm.org/kriasoft/babel-starter-kit#info=devDependencies)
[![Online Chat](http://img.shields.io/badge/chat_room-%23babel--starter--kit-blue.svg?style=flat-square)](https://gitter.im/kriasoft/babel-starter-kit)

> Babel Starter Kit is a project template for authoring and publishing JavaScript libraries using
> [ES2015](https://babeljs.io/docs/learn-es2015/)+ via [Babel](https://babeljs.io/)


### Features

&nbsp; &nbsp; ✓ Author your code, including tests, in [ES2015](https://babeljs.io/docs/learn-es2015/)+ via [Babel](http://babeljs.io/)<br>
&nbsp; &nbsp; ✓ Publish as CommonJS, ES2015 and UMD via [Rollup](http://rollupjs.org/)<br>
&nbsp; &nbsp; ✓ Pre-configured unit tests with [Mocha](http://mochajs.org/), [Chai](http://chaijs.com/) and [Sinon](http://sinonjs.org/)<br>
&nbsp; &nbsp; ✓ Pre-configured test coverage with [Istanbul](https://github.com/gotwarlost/istanbul) and [Coveralls](https://coveralls.io/)<br>
&nbsp; &nbsp; ✓ Generate a homepage for your project with [Easystatic](https://easystatic.com) ([demo](http://www.kriasoft.com/babel-starter-kit/))<br>
&nbsp; &nbsp; ✓ [Yeoman](http://yeoman.io/) generator ([generator-javascript](https://github.com/kriasoft/babel-starter-kit/tree/yeoman-generator))<br>
&nbsp; &nbsp; ✓ Cross-platform, minimum dependencies<br>
&nbsp; &nbsp; ✓ 24/7 community support on [Gitter](https://gitter.im/kriasoft/babel-starter-kit)<br>


### Sponsors

<a href="https://opencollective.com/babel-starter-kit/sponsor/0/website" target="_blank">
  <img src="https://opencollective.com/babel-starter-kit/sponsor/0/avatar.svg" height="64">
</a>
<a href="https://opencollective.com/babel-starter-kit/sponsor/1/website" target="_blank">
  <img src="https://opencollective.com/babel-starter-kit/sponsor/1/avatar.svg" height="64">
</a>
<a href="https://opencollective.com/babel-starter-kit/sponsor/2/website" target="_blank">
  <img src="https://opencollective.com/babel-starter-kit/sponsor/2/avatar.svg" height="64">
</a>
<a href="https://opencollective.com/babel-starter-kit/sponsor/3/website" target="_blank">
  <img src="https://opencollective.com/babel-starter-kit/sponsor/3/avatar.svg" height="64">
</a>
<a href="https://opencollective.com/babel-starter-kit/sponsor/4/website" target="_blank">
  <img src="https://opencollective.com/babel-starter-kit/sponsor/4/avatar.svg" height="64">
</a>


### Documentation

* [Getting Started](docs/getting-started.md)
* [Recipes](docs/recipes)
  * [Testing with <code>mocha</code> and <code>jsdom</code>](docs/recipes/testing-with-mocha-and-jsdom.md)
  * [Throwing errors with FB's <code>invariant</code> library](docs/recipes/throwing-errors-with-fbjs-invariant.md)

See also [www.kriasoft.com/babel-starter-kit](https://www.kriasoft.com/babel-starter-kit/)


### Backers

Love **Babel Starter Kit** work and community? Help us keep it alive by [donating funds](https://opencollective.com/babel-starter-kit#backer)
to cover project expenses!

<a href="https://opencollective.com/babel-starter-kit/backer/0/website" target="_blank">
  <img src="https://opencollective.com/babel-starter-kit/backer/0/avatar.svg" width="64" height="64">
</a>
<a href="https://opencollective.com/babel-starter-kit/backer/1/website" target="_blank">
  <img src="https://opencollective.com/babel-starter-kit/backer/1/avatar.svg" width="64" height="64">
</a>
<a href="https://opencollective.com/babel-starter-kit/backer/2/website" target="_blank">
  <img src="https://opencollective.com/babel-starter-kit/backer/2/avatar.svg" width="64" height="64">
</a>
<a href="https://opencollective.com/babel-starter-kit/backer/3/website" target="_blank">
  <img src="https://opencollective.com/babel-starter-kit/backer/3/avatar.svg" width="64" height="64">
</a>
<a href="https://opencollective.com/babel-starter-kit/backer/4/website" target="_blank">
  <img src="https://opencollective.com/babel-starter-kit/backer/4/avatar.svg" width="64" height="64">
</a>
<a href="https://opencollective.com/babel-starter-kit/backer/5/website" target="_blank">
  <img src="https://opencollective.com/babel-starter-kit/backer/5/avatar.svg" width="64" height="64">
</a>
<a href="https://opencollective.com/babel-starter-kit/backer/6/website" target="_blank">
  <img src="https://opencollective.com/babel-starter-kit/backer/6/avatar.svg" width="64" height="64">
</a>
<a href="https://opencollective.com/babel-starter-kit/backer/7/website" target="_blank">
  <img src="https://opencollective.com/babel-starter-kit/backer/7/avatar.svg" width="64" height="64">
</a>
<a href="https://opencollective.com/babel-starter-kit/backer/8/website" target="_blank">
  <img src="https://opencollective.com/babel-starter-kit/backer/8/avatar.svg" width="64" height="64">
</a>
<a href="https://opencollective.com/babel-starter-kit/backer/9/website" target="_blank">
  <img src="https://opencollective.com/babel-starter-kit/backer/9/avatar.svg" width="64" height="64">
</a>
<a href="https://opencollective.com/babel-starter-kit/backer/10/website" target="_blank">
  <img src="https://opencollective.com/babel-starter-kit/backer/10/avatar.svg" width="64" height="64">
</a>
<a href="https://opencollective.com/babel-starter-kit/backer/11/website" target="_blank">
  <img src="https://opencollective.com/babel-starter-kit/backer/11/avatar.svg" width="64" height="64">
</a>


### Learn ES6

:mortar_board: &nbsp; **[ES6 Training Course](https://es6.io/friend/konstantin)** by Wes Bos<br>
:green_book: &nbsp; **[You Don't Know JS: ES6 & Beyond](http://amzn.to/2bzvV51)** by Kyle Simpson (Dec, 2015)<br>


### Related Projects

* [React Starter Kit](https://github.com/kriasoft/react-starter-kit) — Isomorphic web app boilerplate (Node.js/Express, React.js, GraphQL)
* [React Static Boilerplate](https://github.com/koistya/react-static-boilerplate) — Generate static websites from React components with Webpack
* [Universal Router](https://github.com/kriasoft/universal-router) — Isomorphic router for web and single-page applications (SPA)
* [Membership Database](https://github.com/membership/membership.db) — SQL database boilerplate for web app users, roles and auth tokens


### Get in Touch

* [#babel-starter-kit](https://gitter.im/kriasoft/babel-starter-kit) on Gitter
* [@koistya](https://twitter.com/koistya) on [Codementor](https://www.codementor.io/koistya)


### License

Copyright © 2015-2016 Kriasoft, LLC. This source code is licensed under the MIT license found in
the [LICENSE.txt](https://github.com/kriasoft/react-starter-kit/blob/master/LICENSE.txt) file.
The documentation to the project is licensed under the [CC BY-SA 4.0](http://creativecommons.org/licenses/by-sa/4.0/)
license.


---
Made with ♥ by Konstantin Tarkus ([@koistya](https://twitter.com/koistya)) and [contributors](https://github.com/kriasoft/babel-starter-kit/graphs/contributors)
